# Changelog

All notable changes to this project will be documented in this file.

The format is based on [Keep a Changelog](https://keepachangelog.com/en/1.1.0/),
and this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).
Minor version increments while on version 0.x.x may be treated as major revisions.

## [0.9.8] - 2025-02-12

### Changed

- Removed default units from some of Y-axis in the plot module.
  - All axis have been added as a keyword argument in every method in [`raplan.plot`][raplan.plot].
- Added an optional `name` field to [`CyclicStrategy`][raplan.classes.CyclicStrategy].
- Naming strategy for [`Maintenance`][raplan.classes.Maintenance] generated by a
  [`CyclicStrategy`][raplan.classes.CyclicStrategy] has been updated.

## [0.9.7] - 2025-02-10

### Changed

- Added more tutorial content.
- Added a "progress" calculation for individual maintenance tasks
  [`Maintenance.get_progress`][raplan.classes.Maintenance.get_progress].

## [0.9.6] - 2025-02-06

### Fixed

- Some typing updates.

### Added

- Some initial documentation and tutorial sections for [https://raplan.ratio-case.nl](https://raplan.ratio-case.nl).

## [0.9.5] - 2025-02-05

### Fixed

- Minor function documentation issues.

### Changed

User changes:

- Migrated user documentation on [https://raplan.ratio-case.nl](https://raplan.ratio-case.nl) to MkDocs.

Internal changes:

- Adopted a `src/` layout
- Switched to `uv` for packaging and environment management.
- Setup a `justfile` that abstracts over common tasks.

## [0.9.4] - 2023-11-23

### Changed

- Projection of Excel sheets generated with [`raplan.excel.to_excel`][raplan.excel.to_excel] has been made optional.
  Defaults to False.

## [0.9.3] - 2023-11-22

### Fixed

- Axis for cost and duration in overview plots at set to logarithmic.

## [0.9.2] - 2023-11-22

### Fixed

- Weight calculation for task clustering.

## [0.9.1] - 2023-11-21

### Changed

- Updated dependency constraints.

## [0.9.0] - 2023-11-07

### Changed

- [`raplan.excel.to_excel`][raplan.excel.to_excel] can no longer export multiple projects to a single Excel.

### Fixed

- [`raplan.excel.from_excel`][raplan.excel.from_excel] imports a project from a schedule correctly.
  Incorrect timing of maintenance is fixed.

## [0.8.5] - 2023-05-17

### Fixed

- `DefinedName` creation in Excel exports using openpyxl no longer throws an exception.

## [0.8.4] - 2022-12-12

### Changed

- Introduced longer colormap (20 colors) for generating procedure plots.

## [0.8.3] - 2022-11-24

### Fixed

- Changed to `round()` instead of `int()` when forcing integers when applying the cyclic strategy.

## [0.8.2] - 2022-11-24

### Fixed

- Enforcing integers now results in correct naming of maintenance tasks.

## [0.8.1] - 2022-11-24

### Fixed

- Number serialization with internal tagging.

## [0.8.0] - 2022-11-18

### Added

- A [`raplan.classes.CyclicStrategy`][raplan.classes.CyclicStrategy] class for automatically
  scheduling cyclic maintenance.

## [0.7.1] - 2022-11-08

### Fixed

- Some labeling issues with the procedures plot as well as the hover text.

## [0.7.0] - 2022-11-08

### Added

- A [`raplan.classes.Procedure`][raplan.classes.Procedure] class to use for plotting purposes, as
  well as a [`raplan.plot.get_procedures_plot`][raplan.plot.get_procedures_plot] to plot them with.
  A procedure is meant to represent a standardized set of tasks, but the derivation of a
  [`Procedure`][raplan.classes.Procedure] object from the given default classes within a
  [`Project`][raplan.classes.Project] is left to the user to define.

## [0.6.0] - 2022-11-04

### Changed

- The `x_offset` argument to the higher level [`raplan.plot`][raplan.plot] methods has been replaced
  with a `horizon` argument, that is used to both offset the `x` values and set the plot layout's
  X-axis range. These bounds can still be customized to any value after the fact by settings
  Plotly's layout options in
  [`plotly.graph_objects.Figure.layout.xaxis.range`][plotly.graph_objects.Figure].
- Removed the gap between bars in bar charts by default.

## [0.5.0] - 2022-10-26

### Added

- Excel export functionality under the [`raplan.excel`][raplan.excel] module.
  Re-importing will be added later on.
- Unique identifiers for most classes such that exports can be 1:1 replicated in a round-trip.

### Changed

- Nodes in exports now have more meaningful names instead of only Node UUIDs, which previously
  made visualizations rather obscure.

## [0.4.3] - 2022-10-03

### Fixed

- When converting from a Graph to a Project, only weights that are object properties will be set.
  This allows more data to be present in the Graph without crashing on conversion.

## [0.4.2] - 2022-10-03

### Fixed

- Node labels when converting to Graph are now a proper list.

## [0.4.1] - 2022-10-03

### Fixed

- Check whether nodes are leaf nodes when recreating a Project from a Graph.

## [0.4.0] - 2022-09-30

### Added

- Basic analysis support functionality. Possibility to convert a Project to a Graph and
  vice-versa, as well as opening up the possibility to cluster maintenance tasks (should be done
  in RaGraph) and post-process the results. E.g. sync their start or end times.

### Changed

- Renamed ScheduledTask to ScheduleItem to keep more flexibility in what an item may be(come) and
  reduce confusion with the current Task class.

## [0.3.0] - 2022-09-26

### Added

- Some additional classes supporting a Horizon, Project and Schedule generation.
- Basic plotting module with CFP, cost and duration plots.
- Initial function to obtain a RaGraph graph object to support further analysis.
- Tests to cover all grounds.

## [0.2.0] - 2022-09-22

### Added

- Serializable base classes to support planning and scheduling.

## [0.1.0] - 2022-09-20

### Added

- Package scaffolding.
